import java.util.Locale;

public class Main {
    public static void main(String[] args) {
        DataWorker dw = new DataWorker();
        if(args.length < 7){
            if (args.length <= 1){
                dw.printHelp();
                return;

            }
            System.out.println("ERROR - Wrong number of parameters");
            dw.printHelp();
            return;
        }
        GraphPoint2D[] points = dw.getPoints(args[0]);
        double x1 = dw.getcoordinate(args[3]);
        double y1 = dw.getcoordinate(args[4]);
        double x2 = dw.getcoordinate(args[5]);
        double y2 = dw.getcoordinate(args[6]);
        double endcondition = -1;
        double noprint_dataout = Integer.MAX_VALUE;
        int iterations = -1;
        int print = Integer.MAX_VALUE;
        int reset = Integer.MAX_VALUE;

        String[] test = args[1].split("-");
        if (test[0].equals("s")) {
            double[] conditions = dw.getEndCondition(test);
            endcondition = conditions[0];
            if (conditions.length == 2)
                noprint_dataout = conditions[1];

        }
        else if(test[0].equals("i")){
            iterations = dw.getNumOfIterations(test[1]);
        }
        else {
            System.out.println("ERROR - Wrong stop condition");
            dw.printHelp();
            System.exit(-3);
        }


        if (args.length == 8){
            if(dw.printOrReset(args[7]) == 0)
                print = dw.printTime(args[7]);
            else if (dw.printOrReset(args[7]) == 1)
                reset = dw.resetTime(args[7]);
            else {
                System.out.println("ERROR - TODO");
            }
        }
        if (args.length == 9){
            if (dw.printOrReset(args[7])==0){
                print = dw.printTime(args[7]);
            }
            else if (dw.printOrReset(args[7]) == 1)
                reset = dw.resetTime(args[7]);
            else {
                System.out.println("ERROR");
            }
           if (dw.printOrReset(args[8]) == 0){
               if (print == Integer.MAX_VALUE)
                   print = dw.printTime(args[8]);
               else {
                   System.out.println("ERROR - parameter \'p\' given twice");
                   dw.printHelp();
                   System.exit(-5);
               }
           }
            if (dw.printOrReset(args[8])==1){
                if (reset == Integer.MAX_VALUE)
                    reset = dw.printTime(args[8]);
                else {
                    System.out.println("ERROR - parameter \'r\' given twice");
                    dw.printHelp();
                    System.exit(-5);
                }
            }
        }

        GraphPoint2D[] helping_points = points;
        McQueen mcqueen = new McQueen(2016, 2016, helping_points, x1, y1, x2, y2);
        mcqueen.generate(false, false, "McQueen - " + mcqueen.savePoints.length + "points - before deleting", 0);
        GraphPoint3D[] colors = mcqueen.getColors();

        if (args[2].toLowerCase(Locale.ROOT).equals("create"))
            helping_points = dw.createHoleInData(helping_points, new GraphPoint2D(x1, y1),
                    new GraphPoint2D(x2, y2), colors);

        else if (!args[2].toLowerCase(Locale.ROOT).equals("seek")){
            System.out.println("ERROR - command \'" + args[2] +"\' not recognized");
            dw.printHelp();
            System.exit(-1);
        }
        mcqueen = new McQueen(800, 800, helping_points, x1, y1, x2, y2);
        mcqueen.generate(true, true, "McQueen - " + mcqueen.savePoints.length + " points - start", 0);

        int i = 1;
        if (iterations > 0){
            while(i <= iterations ){
                mcqueen.mcQueenCentralizationOfOnePoint();
                mcqueen.generate(i % print == 0, i % noprint_dataout == 0,
                        "McQueen -" + mcqueen.savePoints.length + " points, iteration no." + i, i);

                i++;
                if(i % reset == 0) {
                    System.out.println(i + " iterations passed, restarting algorithm");
                    for (int j = 0; j < mcqueen.savePoints.length; j++) {
                        mcqueen.savePoints[j].restartUpdating();
                    }
                }
            }
        }
        else if(endcondition >= 0 && endcondition < 1){
            while(((mcqueen.getAverage() + mcqueen.getAverage_inhole_distance()) / 2) >  endcondition) {
                mcqueen.mcQueenCentralizationOfOnePoint();
                mcqueen.generate(i % print == 0, i % noprint_dataout == 0, "McQueen - " +
                        mcqueen.savePoints.length + " points, iteration no." + i, i);

                i++;
                if(i % reset == 0) {
                    System.out.println(i + " iterations passed, restarting algorithm");
                    for (int j = 0; j < mcqueen.savePoints.length; j++) {
                        mcqueen.savePoints[j].restartUpdating();
                    }
                }
            }
        }
        mcqueen.generate(true, true, "McQueen - " + mcqueen.savePoints.length + " end_state", 0);

        mcqueen.closeFile();
        System.out.println("Programm finished");
    }
}
